From 40299e2ccd4d4e96945092fc0c9a7b5c4ceb30c0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 09 2020 01:01:29 +0000
Subject: [PATCH 1006/2232] Merge pull request #347 from dtolnay/cfg


Expose control of import prefix to Cargo builds
---

diff --git a/BUCK b/BUCK
index 0505bd2..22db155 100644
--- a/BUCK
+++ b/BUCK
@@ -53,6 +53,7 @@ rust_library(
     deps = [
         "//third-party:cc",
         "//third-party:codespan-reporting",
+        "//third-party:lazy_static",
         "//third-party:proc-macro2",
         "//third-party:quote",
         "//third-party:syn",
diff --git a/BUILD b/BUILD
index e551d18..782374b 100644
--- a/BUILD
+++ b/BUILD
@@ -59,6 +59,7 @@ rust_library(
     deps = [
         "//third-party:cc",
         "//third-party:codespan-reporting",
+        "//third-party:lazy_static",
         "//third-party:proc-macro2",
         "//third-party:quote",
         "//third-party:syn",
diff --git a/gen/build/Cargo.toml b/gen/build/Cargo.toml
index 675261e..3671781 100644
--- a/gen/build/Cargo.toml
+++ b/gen/build/Cargo.toml
@@ -13,6 +13,7 @@ categories = ["development-tools::ffi"]
 [dependencies]
 cc = "1.0.49"
 codespan-reporting = "0.9"
+lazy_static = "1.4"
 proc-macro2 = { version = "1.0.17", default-features = false, features = ["span-locations"] }
 quote = { version = "1.0", default-features = false }
 syn = { version = "1.0.20", default-features = false, features = ["parsing", "printing", "clone-impls", "full"] }
diff --git a/gen/build/src/cfg.rs b/gen/build/src/cfg.rs
new file mode 100644
index 0000000..05578df
--- /dev/null
+++ b/gen/build/src/cfg.rs
@@ -0,0 +1,184 @@
+use std::fmt::{self, Debug};
+use std::marker::PhantomData;
+
+/// Build configuration. See [CFG].
+pub struct Cfg<'a> {
+    pub include_prefix: &'a str,
+    marker: PhantomData<*const ()>, // !Send + !Sync
+}
+
+/// Global configuration of the current build.
+///
+/// <br>
+///
+/// ## **`CFG.include_prefix`**
+///
+/// Presently the only exposed configuration is the `include_prefix`, the prefix
+/// at which C++ code from your crate as well as directly dependent crates can
+/// access the code generated during this build.
+///
+/// By default, the `include_prefix` is equal to the name of the current crate.
+/// That means if our crate is called `demo` and has Rust source files in a
+/// *src/* directory and maybe some handwritten C++ header files in an
+/// *include/* directory, then the current crate as well as downstream crates
+/// might include them as follows:
+///
+/// ```
+/// # const _: &str = stringify! {
+///   // include one of the handwritten headers:
+/// #include "demo/include/wow.h"
+///
+///   // include a header generated from Rust cxx::bridge:
+/// #include "demo/src/lib.rs.h"
+/// # };
+/// ```
+///
+/// By modifying `CFG.include_prefix` we can substitute a prefix that is
+/// different from the crate name if desired. Here we'll change it to
+/// `"path/to"` which will make import paths take the form
+/// `"path/to/include/wow.h"` and `"path/to/src/lib.rs.h"`.
+///
+/// ```no_run
+/// // build.rs
+///
+/// use cxx_build::CFG;
+///
+/// fn main() {
+///     CFG.include_prefix = "path/to";
+///
+///     cxx_build::bridge("src/lib.rs")
+///         .file("src/demo.cc") // probably contains `#include "path/to/src/lib.rs.h"`
+///         /* ... */
+///         .compile("demo");
+/// }
+/// ```
+///
+/// Note that cross-crate imports are only made available between **direct
+/// dependencies**. Another crate must directly depend on your crate in order to
+/// #include its headers; a transitive dependency is not sufficient.
+/// Additionally, headers from a direct dependency are only importable if the
+/// dependency's Cargo.toml manifest contains a `links` key. If not, its headers
+/// will not be importable from outside of the same crate.
+#[cfg(doc)]
+pub static mut CFG: Cfg = Cfg {
+    include_prefix: "",
+    marker: PhantomData,
+};
+
+impl<'a> Debug for Cfg<'a> {
+    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+        formatter
+            .debug_struct("Cfg")
+            .field("include_prefix", &self.include_prefix)
+            .finish()
+    }
+}
+
+#[cfg(not(doc))]
+pub use self::r#impl::Cfg::CFG;
+
+#[cfg(not(doc))]
+mod r#impl {
+    use lazy_static::lazy_static;
+    use std::cell::RefCell;
+    use std::collections::HashMap;
+    use std::fmt::{self, Debug};
+    use std::marker::PhantomData;
+    use std::ops::{Deref, DerefMut};
+    use std::sync::{PoisonError, RwLock};
+
+    lazy_static! {
+        static ref PACKAGE_NAME: Box<str> = {
+            crate::env_os("CARGO_PKG_NAME")
+                .map(|pkg| pkg.to_string_lossy().into_owned().into_boxed_str())
+                .unwrap_or_default()
+        };
+        static ref INCLUDE_PREFIX: RwLock<Vec<&'static str>> = RwLock::new(vec![&PACKAGE_NAME]);
+    }
+
+    thread_local! {
+        static CONST_DEREFS: RefCell<HashMap<Handle, Box<super::Cfg<'static>>>> = RefCell::default();
+    }
+
+    #[derive(Eq, PartialEq, Hash)]
+    struct Handle(*const Cfg<'static>);
+
+    impl<'a> Cfg<'a> {
+        fn current() -> super::Cfg<'a> {
+            let include_prefix = *INCLUDE_PREFIX
+                .read()
+                .unwrap_or_else(PoisonError::into_inner)
+                .last()
+                .unwrap();
+            super::Cfg {
+                include_prefix,
+                marker: PhantomData,
+            }
+        }
+
+        const fn handle(self: &Cfg<'a>) -> Handle {
+            Handle(<*const Cfg>::cast(self))
+        }
+    }
+
+    // Since super::Cfg is !Send and !Sync, all Cfg are thread local and will
+    // drop on the same thread where they were created.
+    pub enum Cfg<'a> {
+        Mut(super::Cfg<'a>),
+        CFG,
+    }
+
+    impl<'a> Debug for Cfg<'a> {
+        fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+            if let Cfg::Mut(cfg) = self {
+                Debug::fmt(cfg, formatter)
+            } else {
+                Debug::fmt(&Cfg::current(), formatter)
+            }
+        }
+    }
+
+    impl<'a> Deref for Cfg<'a> {
+        type Target = super::Cfg<'a>;
+
+        fn deref(&self) -> &Self::Target {
+            if let Cfg::Mut(cfg) = self {
+                cfg
+            } else {
+                let cfg = CONST_DEREFS.with(|derefs| -> *mut super::Cfg {
+                    &mut **derefs
+                        .borrow_mut()
+                        .entry(self.handle())
+                        .or_insert_with(|| Box::new(Cfg::current()))
+                });
+                unsafe { &mut *cfg }
+            }
+        }
+    }
+
+    impl<'a> DerefMut for Cfg<'a> {
+        fn deref_mut(&mut self) -> &mut Self::Target {
+            if let Cfg::CFG = self {
+                CONST_DEREFS.with(|derefs| derefs.borrow_mut().remove(&self.handle()));
+                *self = Cfg::Mut(Cfg::current());
+            }
+            match self {
+                Cfg::Mut(cfg) => cfg,
+                Cfg::CFG => unreachable!(),
+            }
+        }
+    }
+
+    impl<'a> Drop for Cfg<'a> {
+        fn drop(&mut self) {
+            if let Cfg::Mut(cfg) = self {
+                INCLUDE_PREFIX
+                    .write()
+                    .unwrap_or_else(PoisonError::into_inner)
+                    .push(Box::leak(Box::from(cfg.include_prefix)));
+            } else {
+                CONST_DEREFS.with(|derefs| derefs.borrow_mut().remove(&self.handle()));
+            }
+        }
+    }
+}
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 3782543..267b8cf 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -54,6 +54,7 @@
 )]
 
 mod cargo;
+mod cfg;
 mod error;
 mod gen;
 mod out;
@@ -73,6 +74,8 @@ use std::iter;
 use std::path::{Path, PathBuf};
 use std::process;
 
+pub use crate::cfg::{Cfg, CFG};
+
 /// This returns a [`cc::Build`] on which you should continue to set up any
 /// additional source files or compiler flags, and lastly call its [`compile`]
 /// method to execute the C++ build.
@@ -103,7 +106,7 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 }
 
 struct Project {
-    package_name: OsString,
+    include_prefix: PathBuf,
     manifest_dir: PathBuf,
     // Output directory as received from Cargo.
     out_dir: PathBuf,
@@ -124,7 +127,10 @@ struct Project {
 
 impl Project {
     fn init() -> Result<Self> {
-        let package_name = env_os("CARGO_PKG_NAME")?;
+        let include_prefix = Path::new(CFG.include_prefix);
+        assert!(include_prefix.is_relative());
+        let include_prefix = include_prefix.components().collect();
+
         let manifest_dir = paths::manifest_dir()?;
         let out_dir = paths::out_dir()?;
 
@@ -141,7 +147,7 @@ impl Project {
         };
 
         Ok(Project {
-            package_name,
+            include_prefix,
             manifest_dir,
             out_dir,
             shared_dir,
@@ -239,8 +245,13 @@ fn env_include_dirs() -> impl Iterator<Item = PathBuf> {
 }
 
 fn make_crate_dir(prj: &Project) -> Option<PathBuf> {
+    if prj.include_prefix.as_os_str().is_empty() {
+        let crate_dir = prj.manifest_dir.clone();
+        println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
+        return Some(crate_dir);
+    }
     let crate_dir = prj.out_dir.join("cxxbridge").join("crate");
-    let link = crate_dir.join(&prj.package_name);
+    let link = crate_dir.join(&prj.include_prefix);
     if out::symlink_dir(&prj.manifest_dir, link).is_ok() {
         println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
         Some(crate_dir)
@@ -270,8 +281,8 @@ fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) ->
     let ref rel_path = paths::local_relative_path(rust_source_file);
 
     let cxxbridge = prj.out_dir.join("cxxbridge");
-    let include_dir = cxxbridge.join("include").join(&prj.package_name);
-    let sources_dir = cxxbridge.join("sources").join(&prj.package_name);
+    let include_dir = cxxbridge.join("include").join(&prj.include_prefix);
+    let sources_dir = cxxbridge.join("sources").join(&prj.include_prefix);
 
     let ref rel_path_h = rel_path.with_appended_extension(".h");
     let ref header_path = include_dir.join(rel_path_h);
@@ -285,8 +296,8 @@ fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) ->
     out::write(implementation_path, &generated.implementation)?;
     build.file(implementation_path);
 
-    let shared_h = prj.shared_dir.join(&prj.package_name).join(rel_path_h);
-    let shared_cc = prj.shared_dir.join(&prj.package_name).join(rel_path_cc);
+    let shared_h = prj.shared_dir.join(&prj.include_prefix).join(rel_path_h);
+    let shared_cc = prj.shared_dir.join(&prj.include_prefix).join(rel_path_cc);
     let _ = out::symlink_file(header_path, shared_h);
     let _ = out::symlink_file(implementation_path, shared_cc);
     Ok(())
diff --git a/tests/BUCK b/tests/BUCK
index 47fc557..f066542 100644
--- a/tests/BUCK
+++ b/tests/BUCK
@@ -26,10 +26,9 @@ cxx_library(
         ":bridge/source",
         ":module/source",
     ],
-    header_namespace = "cxx-test-suite",
     headers = {
-        "lib.rs.h": ":bridge/header",
-        "tests.h": "ffi/tests.h",
+        "ffi/lib.rs.h": ":bridge/header",
+        "ffi/tests.h": "ffi/tests.h",
     },
     deps = ["//:core"],
 )
diff --git a/tests/BUILD b/tests/BUILD
index 68e7be3..1345a7a 100644
--- a/tests/BUILD
+++ b/tests/BUILD
@@ -29,8 +29,6 @@ cc_library(
         ":module/source",
     ],
     hdrs = ["ffi/tests.h"],
-    include_prefix = "cxx-test-suite",
-    strip_include_prefix = "ffi",
     deps = [
         ":bridge/include",
         "//:core",
@@ -40,15 +38,11 @@ cc_library(
 rust_cxx_bridge(
     name = "bridge",
     src = "ffi/lib.rs",
-    include_prefix = "cxx-test-suite",
-    strip_include_prefix = "ffi",
     deps = [":impl"],
 )
 
 rust_cxx_bridge(
     name = "module",
     src = "ffi/module.rs",
-    include_prefix = "cxx-test-suite",
-    strip_include_prefix = "ffi",
     deps = [":impl"],
 )
diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index 8042129..e583944 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -1,8 +1,11 @@
+use cxx_build::CFG;
+
 fn main() {
     if cfg!(trybuild) {
         return;
     }
 
+    CFG.include_prefix = "tests/ffi";
     let sources = vec!["lib.rs", "module.rs"];
     cxx_build::bridges(sources)
         .file("tests.cc")
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 9ace1f2..cc07752 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -23,7 +23,7 @@ pub mod ffi {
     }
 
     extern "C" {
-        include!("cxx-test-suite/tests.h");
+        include!("tests/ffi/tests.h");
 
         type C;
 
diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
index 8862dc1..77bae06 100644
--- a/tests/ffi/module.rs
+++ b/tests/ffi/module.rs
@@ -4,7 +4,7 @@
 #[cxx::bridge(namespace = tests)]
 pub mod ffi {
     extern "C" {
-        include!("cxx-test-suite/tests.h");
+        include!("tests/ffi/tests.h");
 
         type C = crate::ffi::C;
 
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 1f88d8b..9cb6ed0 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -1,5 +1,5 @@
-#include "cxx-test-suite/tests.h"
-#include "cxx-test-suite/lib.rs.h"
+#include "tests/ffi/tests.h"
+#include "tests/ffi/lib.rs.h"
 #include <cstring>
 #include <iterator>
 #include <numeric>
diff --git a/third-party/BUCK b/third-party/BUCK
index e6a5611..3b0ec99 100644
--- a/third-party/BUCK
+++ b/third-party/BUCK
@@ -36,6 +36,7 @@ rust_library(
 rust_library(
     name = "lazy_static",
     srcs = glob(["vendor/lazy_static-1.4.0/src/**"]),
+    visibility = ["PUBLIC"],
 )
 
 rust_library(
diff --git a/third-party/BUILD b/third-party/BUILD
index f874d07..3477326 100644
--- a/third-party/BUILD
+++ b/third-party/BUILD
@@ -41,6 +41,7 @@ rust_library(
 rust_library(
     name = "lazy_static",
     srcs = glob(["vendor/lazy_static-1.4.0/src/**"]),
+    visibility = ["//visibility:public"],
 )
 
 rust_library(
diff --git a/tools/bazel/rust_cxx_bridge.bzl b/tools/bazel/rust_cxx_bridge.bzl
index d4111c6..534f6b5 100644
--- a/tools/bazel/rust_cxx_bridge.bzl
+++ b/tools/bazel/rust_cxx_bridge.bzl
@@ -1,12 +1,7 @@
 load("@bazel_skylib//rules:run_binary.bzl", "run_binary")
 load("@rules_cc//cc:defs.bzl", "cc_library")
 
-def rust_cxx_bridge(
-        name,
-        src,
-        include_prefix = None,
-        strip_include_prefix = None,
-        deps = []):
+def rust_cxx_bridge(name, src, deps = []):
     native.alias(
         name = "%s/header" % name,
         actual = src + ".h",
@@ -43,6 +38,4 @@ def rust_cxx_bridge(
     cc_library(
         name = "%s/include" % name,
         hdrs = [src + ".h"],
-        include_prefix = include_prefix,
-        strip_include_prefix = strip_include_prefix,
     )

